## EDU.oswego.cs.dl.util.concurrent.misc
Class FIFOSlot

    java.lang.Object
      |
      +--EDU.oswego.cs.dl.util.concurrent.misc.FIFOSlot

All Implemented Interfaces:
  BoundedChannel, Channel, Puttable, Takable

public class FIFOSlot
extends java.lang.Object
implements BoundedChannel

Constructor Summary
`FIFOSlot()`

Method Summary
`int` `capacity()` Return the maximum number of elements that can be held.
`boolean` `offer(java.lang.Object item, long msecs)` Place item in channel only if it can be accepted within msecs milliseconds.
`java.lang.Object` `peek()` Return, but do not remove object at head of Channel, or null if it is empty.
`java.lang.Object` `poll(long msecs)` Return and remove an item from channel only if one is available within msecs milliseconds.
`void` `put(java.lang.Object item)` Place item in the channel, possibly waiting indefinitely until it can be accepted.
`java.lang.Object` `take()` Return and remove an item from channel, possibly waiting indefinitely until such an item exists.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FIFOSlot

    public FIFOSlot()

Method Detail

### put

    public void put(java.lang.Object item)
             throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Place item in the channel, possibly waiting indefinitely until it can be accepted. Channels implementing the BoundedChannel subinterface are generally guaranteed to block on puts upon reaching capacity, but other implementations may or may not block.

  Specified by:
    `put` in interface `Channel`
  Parameters:
    `item` - the element to be inserted. Should be non-null.
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted. Otherwise, on normal return, the element is guaranteed to have been inserted.

### offer

    public boolean offer(java.lang.Object item,
                         long msecs)
                  throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Place item in channel only if it can be accepted within msecs milliseconds. The time bound is interpreted in a coarse-grained, best-effort fashion.

  Specified by:
    `offer` in interface `Channel`
  Parameters:
    `item` - the element to be inserted. Should be non-null.
    `msecs` - the number of milliseconds to wait. If less than or equal to zero, the method does not perform any timed waits, but might still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention for the channel.
  Returns:
    true if accepted, else false
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case the element is guaranteed not to be inserted (i.e., is equivalent to a false return).

### take

    public java.lang.Object take()
                          throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Return and remove an item from channel, possibly waiting indefinitely until such an item exists.

  Specified by:
    `take` in interface `Channel`
  Returns:
    some item from the channel. Different implementations may guarantee various properties (such as FIFO) about that item
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case state of the channel is unchanged.

### poll

    public java.lang.Object poll(long msecs)
                          throws java.lang.InterruptedException

  Description copied from interface: `Channel`
  Return and remove an item from channel only if one is available within msecs milliseconds. The time bound is interpreted in a coarse grained, best-effort fashion.

  Specified by:
    `poll` in interface `Channel`
  Parameters:
    `msecs` - the number of milliseconds to wait. If less than or equal to zero, the operation does not perform any timed waits, but might still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention for the channel.
  Returns:
    some item, or null if the channel is empty.
  Throws:
    `java.lang.InterruptedException` - if the current thread has been interrupted at a point at which interruption is detected, in which case state of the channel is unchanged (i.e., equivalent to a null return).

### capacity

    public int capacity()

  Description copied from interface: `BoundedChannel`
  Return the maximum number of elements that can be held.

  Specified by:
    `capacity` in interface `BoundedChannel`
  Returns:
    the capacity of this channel.

### peek

    public java.lang.Object peek()

  Description copied from interface: `Channel`
  Return, but do not remove object at head of Channel, or null if it is empty.

  Specified by:
    `peek` in interface `Channel`